! ---------------------------------------------------------------------------
!  Decon1D_TLS.f90 - Created by Morgan Brown
!           Tue Jun 11 10:13:31 2002.
! ---------------------------------------------------------------------------
!       Usage: Decon1D_TLS.x 
!  Parameters: 
! Description: 
! ---------------------------------------------------------------------------
program Decon1D_TLS

use sep
use icai1
use solver_smp_mod
use solver_reg_mod
use scaled_identity
use cgstep_mod

implicit none

integer                    :: n1, nf, imodeling, iinv, stat, niter, ireg
real                       :: d1, d2, o1, o2, eps
real, dimension(:), pointer :: filt, model, data
logical                    :: modeling, inv, reg

call sep_init(SOURCE)

call from_aux( 'filt', 'n1', nf)
allocate( filt(nf) )
call sep_read( filt, 'filt')

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call to_history('n1',n1);   call to_history('d1',d1);   call to_history('o1',o1)

call from_param( 'inv', iinv, 0); inv=(iinv==1)
call from_param( 'modeling', imodeling, 0); modeling=(imodeling==1)
call from_param( 'niter', niter, 10)

call from_param( 'reg', ireg, 0); reg=(ireg==1)
call from_param( 'eps', eps, 1.0)

if( inv) then                          ! m = TLS_inv(B,d)
	allocate( data(n1), model(n1+1) )
	call sep_read( data)
	call icai1_init(filt,0)
	if( reg) then
		call solver_reg( model, data, icai1_lop, identity_exec, cgstep, n1, niter, eps, verb=.true.)
	else
		call solver_smp( model, data, icai1_lop, cgstep, niter, verb=.true.)
	end if
	call sep_write( model(1:n1) )
else
	allocate( data(n1), model(n1) )
	if( modeling) then                    ! Bm = d
		call sep_read( model)
		call icai1_init(filt,0)
		stat = icai1_lop( .false., .false., model, data)		
		call sep_write( data)
	else                                  ! m = B'd
		call sep_read( data)
		call icai1_init(filt,0)
		stat = icai1_lop( .true., .false., model, data)		
		call sep_write( model)
	end if
end if

deallocate( model, data, filt)

call exit(0)

end program Decon1D_TLS
