! ---------------------------------------------------------------------------
!  Decon1D_TLS.f90 - Created by Morgan Brown
!           Tue Jun 11 10:13:31 2002.
! ---------------------------------------------------------------------------
!       Usage: Decon1D_TLS.x 
!  Parameters: 
! Description: 
! ---------------------------------------------------------------------------
program Decon1D_TLS

use sep
use tcai1
use solver_reg_mod
use scaled_identity
use cgstep_mod

implicit none

integer                     :: i,n1, nf,stat, niter
real                        :: d1, d2, o1, o2, eps
real, dimension(:), pointer :: filt, model, data, data1

call sep_init(SOURCE)

call from_aux( 'filt', 'n1', nf)
allocate( filt(nf) )
call sep_read( filt, 'filt')

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call to_history('n1',n1);   call to_history('d1',d1);   call to_history('o1',o1)

call from_param( 'niter', niter, 10)
call from_param( 'eps', eps, 1.0)

allocate( data(n1), model(n1), data1(n1+nf-1) )
call sep_read( data)
do i=1,n1
  data1(i)=data(i)
end do
do i=n1+1,n1+nf-1
  data1(i)=0.
end do  
call tcai1_init(filt)
call solver_reg( model, data1, tcai1_lop, identity_exec, cgstep, n1, niter, eps, verb=.true.)
call sep_write( model(1:n1) )

deallocate( model, data, filt, data1)

call exit(0)

end program Decon1D_TLS
