! ---------------------------------------------------------------------------
!  Decon1D_TLS.f90 - Created by Morgan Brown
!           Tue Jun 11 10:13:31 2002.
! ---------------------------------------------------------------------------
!       Usage: Decon1D_TLS.x 
!  Parameters: 
! Description: 
! ---------------------------------------------------------------------------
program Decon1D_TLS

use sep
!use tcai1
use solver_reg_mod
use scaled_identity
use cgstep_mod
use kron_filt2

implicit none

integer                     :: i,n,n1,n2, nf,nf1,nf2,stat, niter,d
real                        :: d1, d2, o1, o2, eps
real, dimension(:), pointer :: model, data
real, dimension(:,:), pointer :: filt1,filt2

call sep_init(SOURCE)

call from_aux( 'filt', 'n1', nf1)
call from_aux( 'filt', 'n2', nf2)
nf=nf1*nf2
allocate( filt1(nf1,nf2) )
call sep_read( filt1, 'filt')
allocate( filt2(nf1,nf2) )
call sep_read( filt2, 'filt')

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call to_history('n1',n1);   call to_history('d1',d1);   call to_history('o1',o1)
call to_history('n2',n2);   call to_history('d2',d2);   call to_history('o2',o2)

n=n1*n2
call from_param( 'niter', niter, 10)
call from_param( 'eps', eps, 1.0)
call from_param( 'd', d, 40)

allocate( data(n), model(n))
call sep_read( data)
write(0,*) "1"
!call init_kron(filt1,filt2,d)
if(.not. init_kron(filt1,filt2,d)) then
 write(0,*) "initializing kron"
end if
write(0,*) "2"
call solver_reg( model, data, kron_filt_op, identity_exec, cgstep, n, niter, eps, verb=.true.)
call sep_write( model(1:n) )
write(0,*) "3"
deallocate( model, data, filt1,filt2)

call exit(0)

end program Decon1D_TLS
