module Gradmag_mod
use igrad2
implicit none
contains

  subroutine gradmag (model,wei,n1,n2)

  integer,           intent(in)      :: n1,n2
  real, dimension(:),intent(in)      :: model
  real, dimension(:),intent(out)     :: wei 
  real, dimension(:),allocatable     :: tmp  
  integer :: stat
   
  allocate (tmp(n1*n2*2))
 
  call igrad2_init(n1,n2)

  stat = igrad2_lop(.false.,.false.,model,tmp)

  wei = sqrt(tmp(1:n1*n2)**2+tmp(n1*n2+1:n1*n2*2)**2)

  deallocate (tmp)

  end subroutine gradmag
end module Gradmag_mod  
