module blur_mod
use adj_mod
implicit none
real,pointer,private :: A(:,:),B(:,:)
real,allocatable :: tmp_Bg(:,:)
integer,private :: n
contains

subroutine blur_init(A1,B1,m)
integer :: m
real,pointer:: A1(:,:),B1(:,:)
A=>A1
B=>B1
n=m
allocate(tmp_Bg(n,n))
end subroutine blur_init


integer function blur_op(adj,add,model,data)
logical,intent(in) :: adj,add
real    :: model(:),data(:)
call adjnull(adj,add,model,data)
call blr(adj,add,model,data)
blur_op=0
end function blur_op

subroutine blr(adj,add,model,data)
logical,intent(in):: adj,add
real :: model(n,n),data(n,n)
integer :: i1,i2
tmp_Bg=0.0
if (.not. adj) then
  do i2=1,n
    call blur_vector(adj,add,model(:,i2),tmp_Bg(:,i2)) 
  end do
  call blur_mtr(adj,add,tmp_Bg,data)
else
  do i2=1,n
    call blur_vector(adj,add,tmp_Bg(:,i2),data(:,i2))
  end do
  call blur_mtr(adj,add,model,tmp_Bg)
end if

end subroutine blr


subroutine blur_mtr(adj,add,model,data)
logical,intent(in):: adj,add
real   :: model(n,n),data(n,n)
integer :: i1,i2
do i2=1,n
  do i1=1,n
    if (.not. adj) then
      data(:,i2)=data(:,i2)+A(i1,i2)*model(:,i1)
    else
      model(:,i1)=model(:,i1)+A(i1,i2)*data(:,i2)
    end if    
  end do
end do
end subroutine blur_mtr


subroutine blur_vector(adj,add,model,data)
logical,intent(in):: adj,add
real :: model(n),data(n)
integer :: i1,i2

do i2=1,n
  do i1=1,n
     if (.not. adj) then
       data(i2)=data(i2)+B(i1,i2)*model(i1)
     else
       model(i1)=model(i1)+B(i1,i2)*data(i2)
     end if
  end do
end do

end subroutine blur_vector

subroutine blur_release
deallocate(tmp_Bg)
end subroutine blur_release

end module blur_mod
