module kron_filt2 
use adj_mod
implicit none
real, pointer,private :: p1(:,:),p2(:,:)
integer,private,save :: n1,dist
contains


logical function init_kron(f1,f2,d)
real, pointer :: f1(:,:),f2(:,:)
integer :: d
p1=>f1
p2=>f2
n1=size(f1,2)
dist=d
init_kron=.true.
end function 

integer function kron_filt_op(adj,add,model,data)
logical, intent(in) :: adj,add
real :: model(:),data(:)
integer :: i,j,k,l,m,n
call adjnull(adj,add,model,data)
call kron2(adj,add,model,data)
kron_filt_op=0
end function 

subroutine kron2(adj,add,model,data)
logical, intent(in) :: adj,add
real :: model(n1,n1),data(n1,n1)
integer :: i,j,k,l,m,n,i1,i2,j1,j2
i=0
do i2=1,n1 
  if (mod(i2,64).eq.1) then
    write(0,*) "FOR",i2
  end if
  do i1=1,n1 
    i=i+1
    m=(i-1)/size(p1,1)+1
    n=mod(i-1,size(p1,1))+1
    do j2=max(i2-dist,1),min(i2+dist,n1)
      do j1=max(i1-dist,1),min(i1+dist,n1)
        j=j1+(j2-1)*n1
        k=(j-1)/size(p1,1)+1
        l=mod(j-1,size(p1,1))+1
        if (.not. adj) then
          data(i1,i2)=data(i1,i2)+model(j1,j2)*p1(k,m)*p2(l,n)
        else
          model(j1,j2)=model(j1,j2)+data(i1,i2)*p1(k,m)*p2(l,n)
        end if
      end do
    end do
  end do
end do
end subroutine 

end module 
